# coding: utf-8

"""
    FINBOURNE Workflow API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict
from pydantic.v1 import StrictStr, Field, BaseModel, Field 
from lusid_workflow.models.date_adjustment import DateAdjustment
from lusid_workflow.models.time_adjustment import TimeAdjustment

class ScheduledTimeAdjustment(BaseModel):
    """
    Represents an adjustment to the scheduled time of an EventHandler. Only relevant for EventHandlers with a  Finbourne.Workflow.WebApi.Common.Dto.Json.EventHandlers.ScheduleMatchingPattern  # noqa: E501
    """
    date_adjustment: DateAdjustment = Field(..., alias="dateAdjustment")
    time_adjustment: TimeAdjustment = Field(..., alias="timeAdjustment")
    __properties = ["dateAdjustment", "timeAdjustment"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ScheduledTimeAdjustment:
        """Create an instance of ScheduledTimeAdjustment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of date_adjustment
        if self.date_adjustment:
            _dict['dateAdjustment'] = self.date_adjustment.to_dict()
        # override the default output from pydantic by calling `to_dict()` of time_adjustment
        if self.time_adjustment:
            _dict['timeAdjustment'] = self.time_adjustment.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ScheduledTimeAdjustment:
        """Create an instance of ScheduledTimeAdjustment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ScheduledTimeAdjustment.parse_obj(obj)

        _obj = ScheduledTimeAdjustment.parse_obj({
            "date_adjustment": DateAdjustment.from_dict(obj.get("dateAdjustment")) if obj.get("dateAdjustment") is not None else None,
            "time_adjustment": TimeAdjustment.from_dict(obj.get("timeAdjustment")) if obj.get("timeAdjustment") is not None else None
        })
        return _obj
